Index: src/Fl_x.cxx
===================================================================
--- src/Fl_x.cxx	(Revision 12431)
+++ src/Fl_x.cxx	(Arbeitskopie)
@@ -1409,13 +1409,6 @@
       Fl::e_text = sn_buffer ? (char*)sn_buffer : (char *)"";
       Fl::e_length = bytesread;
       }
-    int old_event = Fl::e_number;
-    int retval = fl_selection_requestor->handle(Fl::e_number = FL_PASTE);
-    if (!retval && Fl::e_clipboard_type == Fl::clipboard_image) {
-      delete (Fl_RGB_Image*)Fl::e_clipboard_data;
-      Fl::e_clipboard_data= NULL;
-    }
-    Fl::e_number = old_event;
     // Detect if this paste is due to Xdnd by the property name (I use
     // XA_SECONDARY for that) and send an XdndFinished message. It is not
     // clear if this has to be delayed until now or if it can be done
@@ -1426,6 +1419,13 @@
                            fl_xevent->xselection.requestor);
       fl_dnd_source_window = 0; // don't send a second time
     }
+    int old_event = Fl::e_number;
+    int retval = fl_selection_requestor->handle(Fl::e_number = FL_PASTE);
+    if (!retval && Fl::e_clipboard_type == Fl::clipboard_image) {
+      delete (Fl_RGB_Image*)Fl::e_clipboard_data;
+      Fl::e_clipboard_data= NULL;
+    }
+    Fl::e_number = old_event;
     return 1;}
 
   case SelectionClear: {
